import * as Transport from 'winston-transport';
import { LoggerContext } from './logger';
export interface HttpTransportOptions extends Transport.TransportStreamOptions {
    url: string;
    auth?: {
        username?: string | undefined;
        password?: string | undefined;
        bearer?: string | undefined;
    };
    headers?: Record<string, any>;
    payload?: (payload: LoggerContext) => any;
}
export declare class HttpTransport extends Transport {
    private options;
    constructor(options: HttpTransportOptions);
    log(info: any, next: () => void): void;
    private request;
}
