"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LoggerModule = exports.LoggerService = exports.Logger = void 0;
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
const logger_1 = require("./logger");
Object.defineProperty(exports, "Logger", { enumerable: true, get: function () { return logger_1.Logger; } });
let LoggerService = class LoggerService {
    constructor(request, inquier, logger) {
        this.request = request;
        this.inquier = inquier;
        this.logger = logger;
    }
    getContext(context) {
        var _a;
        context = typeof context === 'object' ? context : { context };
        if (!context.context) {
            context.context = (_a = this.inquier) === null || _a === void 0 ? void 0 : _a.constructor.name;
        }
        return this.logger.getContext(context, this.request);
    }
    log(message, context) {
        this.logger.log(message, this.getContext(context));
    }
    error(message, trace, context) {
        this.logger.error(message, trace, this.getContext(context));
    }
    warn(message, context) {
        this.logger.warn(message, this.getContext(context));
    }
    debug(message, context) {
        this.logger.debug(message, this.getContext(context));
    }
    verbose(message, context) {
        this.logger.verbose(message, this.getContext(context));
    }
};
LoggerService = __decorate([
    (0, common_1.Injectable)({ scope: common_1.Scope.TRANSIENT }),
    __param(0, (0, common_1.Inject)(core_1.REQUEST)),
    __param(1, (0, common_1.Inject)(core_1.INQUIRER)),
    __param(2, (0, common_1.Inject)(logger_1.Logger)),
    __metadata("design:paramtypes", [Object, Object, logger_1.Logger])
], LoggerService);
exports.LoggerService = LoggerService;
class LoggerModule {
    static forRoot(options) {
        const logger = new logger_1.Logger(options);
        return {
            global: true,
            module: LoggerModule,
            providers: [
                {
                    provide: logger_1.Logger,
                    useValue: logger,
                },
                LoggerService,
            ],
            exports: [LoggerService, logger_1.Logger],
        };
    }
}
exports.LoggerModule = LoggerModule;
