import * as DailyRotateFile from 'winston-daily-rotate-file';
import { LogLevel } from '@nestjs/common';
import { Request } from 'express';
import { HttpTransportOptions } from './http';
export type ConstructOptions = DailyRotateFile.DailyRotateFileTransportOptions & {
    context?: string | ((request: Request) => object);
    level?: LogLevel;
    http?: HttpTransportOptions;
};
export interface LoggerContext {
    context?: string;
    [name: string]: any;
}
export declare class Logger {
    private options;
    private context?;
    private loggers;
    private level;
    constructor(options: ConstructOptions, context?: LoggerContext | undefined);
    getContext(context: string | {
        context?: string;
        [name: string]: any;
    }, request: Request): LoggerContext;
    all(level: LogLevel, message: any, context?: LoggerContext, trace?: string): any;
    setLevel(level?: LogLevel): void;
    error(message: any, trace?: string, context?: LoggerContext): void;
    log(message: any, context?: LoggerContext): void;
    warn(message: any, context?: LoggerContext): void;
    debug(message: any, context?: LoggerContext): void;
    verbose(message: any, context?: LoggerContext): void;
}
